## safeint 3.0.28a%2Bdfsg

=== debian/changelog ===
safeint (3.0.28a+dfsg-4) unstable; urgency=medium

  * Add Multi-Arch: foreign
  * Standards-Version: 4.7.0 (no changes required)

 -- Dylan Aïssi <daissi@debian.org>  Tue, 03 Dec 2024 10:21:25 +0100

safeint (3.0.28a+dfsg-3) unstable; urgency=medium

  * Disable broken tests with GCC 13 (Closes: #1042152)

 -- Dylan Aïssi <daissi@debian.org>  Fri, 10 Nov 2023 17:08:35 +0100

safeint (3.0.28a+dfsg-2) unstable; urgency=medium

  * Source only upload to unstable

 -- Dylan Aïssi <daissi@debian.org>  Thu, 25 May 2023 15:23:25 +0200

safeint (3.0.28a+dfsg-1) experimental; urgency=medium

  * Initial release

 -- Dylan Aïssi <daissi@debian.org>  Wed, 17 May 2023 11:17:11 +0200
