=== debian/changelog ===
safeint (3.0.28a+dfsg-5) unstable; urgency=medium

  * Improve d/watch
  * Update debian/copyright
  * Add debian/upstream/metadata
  * Add debian/salsa-ci.yml
  * Standards-Version: 4.7.2 (no changes required)
  * Update DEP3 header of Fix_gcc13.patch

 -- Dylan Aïssi <daissi@debian.org>  Wed, 13 Aug 2025 08:11:29 +0200
