=== debian/control ===
Source: safeint
Section: libdevel
Priority: optional
Maintainer: Debian Deep Learning Team <debian-ai@lists.debian.org>
Uploaders: Dylan Aïssi <daissi@debian.org>
Build-Depends: debhelper-compat (= 13),
               cmake
Standards-Version: 4.7.2
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/deeplearning-team/safeint
Vcs-Git: https://salsa.debian.org/deeplearning-team/safeint.git
Homepage: https://github.com/dcleblanc/SafeInt

Package: libsafeint-dev
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: class library for C++ that manages integer overflows
 SafeInt is a class library for C++ that manages integer overflows. It also
 includes a C library that checks casting, multiplication, division, addition
 and subtraction for all combinations of signed and unsigned 32-bit and 64-bit
 integers.
