=== debian/watch ===
version=4
opts="uversionmangle=s/3.2/3.0.2/,repacksuffix=+dfsg,dversionmangle=s/\+dfsg//g" \
 https://github.com/dcleblanc/SafeInt/tags .*/v?(\d.*)@ARCHIVE_EXT@
